Index: branches/2521_ProblemRefactoring/HeuristicLab 3.3.sln
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab 3.3.sln	(revision 17954)
+++ branches/2521_ProblemRefactoring/HeuristicLab 3.3.sln	(revision 17955)
@@ -460,6 +460,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.Scheduling-3.3", "HeuristicLab.Problems.Scheduling\3.3\HeuristicLab.Problems.Scheduling-3.3.csproj", "{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.Scheduling.Views-3.3", "HeuristicLab.Problems.Scheduling.Views\3.3\HeuristicLab.Problems.Scheduling.Views-3.3.csproj", "{78763A4E-E163-48C2-98EB-709760D06F25}"
 EndProject
 Global
@@ -2245,16 +2243,4 @@
 		{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}.Release|x86.ActiveCfg = Release|x86
 		{2BF1D639-1A74-44ED-AAAD-41ECD395AD93}.Release|x86.Build.0 = Release|x86
-		{78763A4E-E163-48C2-98EB-709760D06F25}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{78763A4E-E163-48C2-98EB-709760D06F25}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{78763A4E-E163-48C2-98EB-709760D06F25}.Debug|x64.ActiveCfg = Debug|x64
-		{78763A4E-E163-48C2-98EB-709760D06F25}.Debug|x64.Build.0 = Debug|x64
-		{78763A4E-E163-48C2-98EB-709760D06F25}.Debug|x86.ActiveCfg = Debug|x86
-		{78763A4E-E163-48C2-98EB-709760D06F25}.Debug|x86.Build.0 = Debug|x86
-		{78763A4E-E163-48C2-98EB-709760D06F25}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{78763A4E-E163-48C2-98EB-709760D06F25}.Release|Any CPU.Build.0 = Release|Any CPU
-		{78763A4E-E163-48C2-98EB-709760D06F25}.Release|x64.ActiveCfg = Release|x64
-		{78763A4E-E163-48C2-98EB-709760D06F25}.Release|x64.Build.0 = Release|x64
-		{78763A4E-E163-48C2-98EB-709760D06F25}.Release|x86.ActiveCfg = Release|x86
-		{78763A4E-E163-48C2-98EB-709760D06F25}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
Index: branches/2521_ProblemRefactoring/HeuristicLab.Optimization.Views/3.3/ProblemView.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Optimization.Views/3.3/ProblemView.cs	(revision 17954)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Optimization.Views/3.3/ProblemView.cs	(revision 17955)
@@ -37,6 +37,4 @@
       set { base.Content = value; }
     }
-
-
 
     /// <summary>
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering.Views/3.3/HeuristicLab.Problems.Orienteering.Views-3.3.csproj
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering.Views/3.3/HeuristicLab.Problems.Orienteering.Views-3.3.csproj	(revision 17954)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering.Views/3.3/HeuristicLab.Problems.Orienteering.Views-3.3.csproj	(revision 17955)
@@ -113,8 +113,4 @@
     <Compile Include="OrienteeringProblemDataView.Designer.cs">
       <DependentUpon>OrienteeringProblemDataView.cs</DependentUpon>
-    </Compile>
-    <Compile Include="OrienteeringProblemView.cs" />
-    <Compile Include="OrienteeringProblemView.Designer.cs">
-      <DependentUpon>OrienteeringProblemView.cs</DependentUpon>
     </Compile>
     <Compile Include="OrienteeringSolutionView.cs">
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering.Views/3.3/OrienteeringProblemView.Designer.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering.Views/3.3/OrienteeringProblemView.Designer.cs	(revision 17954)
+++ 	(revision )
@@ -1,151 +1,0 @@
-﻿//#region License Information
-///* HeuristicLab
-// * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
-// *
-// * This file is part of HeuristicLab.
-// *
-// * HeuristicLab is free software: you can redistribute it and/or modify
-// * it under the terms of the GNU General Public License as published by
-// * the Free Software Foundation, either version 3 of the License, or
-// * (at your option) any later version.
-// *
-// * HeuristicLab is distributed in the hope that it will be useful,
-// * but WITHOUT ANY WARRANTY; without even the implied warranty of
-// * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// * GNU General Public License for more details.
-// *
-// * You should have received a copy of the GNU General Public License
-// * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
-// */
-//#endregion
-
-//namespace HeuristicLab.Problems.Orienteering.Views {
-//  partial class OrienteeringProblemView {
-//    /// <summary> 
-//    /// Required designer variable.
-//    /// </summary>
-//    private System.ComponentModel.IContainer components = null;
-
-//    protected override void Dispose(bool disposing) {
-//      if (disposing && (components != null)) {
-//        components.Dispose();
-//      }
-//      base.Dispose(disposing);
-//    }
-
-//    #region Component Designer generated code
-
-//    /// <summary> 
-//    /// Required method for Designer support - do not modify 
-//    /// the contents of this method with the code editor.
-//    /// </summary>
-//    private void InitializeComponent() {
-//      this.tabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
-//      this.parametersTabPage = new System.Windows.Forms.TabPage();
-//      this.visualizationTabPage = new System.Windows.Forms.TabPage();
-//      this.orienteeringSolutionView = new HeuristicLab.Problems.Orienteering.Views.OrienteeringSolutionView();
-//      ((System.ComponentModel.ISupportInitialize)(this.problemInstanceSplitContainer)).BeginInit();
-//      this.problemInstanceSplitContainer.Panel1.SuspendLayout();
-//      this.problemInstanceSplitContainer.Panel2.SuspendLayout();
-//      this.problemInstanceSplitContainer.SuspendLayout();
-//      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
-//      this.tabControl.SuspendLayout();
-//      this.parametersTabPage.SuspendLayout();
-//      this.visualizationTabPage.SuspendLayout();
-//      this.SuspendLayout();
-//      // 
-//      // problemInstanceSplitContainer
-//      // 
-//      // 
-//      // problemInstanceSplitContainer.Panel2
-//      // 
-//      this.problemInstanceSplitContainer.Panel2.Controls.Add(this.tabControl);
-//      // 
-//      // parameterCollectionView
-//      // 
-//      this.parameterCollectionView.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)));
-//      this.parameterCollectionView.Dock = System.Windows.Forms.DockStyle.Fill;
-//      this.parameterCollectionView.Location = new System.Drawing.Point(3, 3);
-//      this.parameterCollectionView.Size = new System.Drawing.Size(497, 274);
-//      // 
-//      // nameTextBox
-//      // 
-//      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-//      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
-//      // 
-//      // tabControl
-//      // 
-//      this.tabControl.AllowDrop = true;
-//      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-//                  | System.Windows.Forms.AnchorStyles.Left)
-//                  | System.Windows.Forms.AnchorStyles.Right)));
-//      this.tabControl.Controls.Add(this.parametersTabPage);
-//      this.tabControl.Controls.Add(this.visualizationTabPage);
-//      this.tabControl.Location = new System.Drawing.Point(0, 27);
-//      this.tabControl.Name = "tabControl";
-//      this.tabControl.SelectedIndex = 0;
-//      this.tabControl.Size = new System.Drawing.Size(511, 306);
-//      this.tabControl.TabIndex = 4;
-//      // 
-//      // parametersTabPage
-//      // 
-//      this.parametersTabPage.BackColor = System.Drawing.SystemColors.Window;
-//      this.parametersTabPage.Controls.Add(this.parameterCollectionView);
-//      this.parametersTabPage.Location = new System.Drawing.Point(4, 22);
-//      this.parametersTabPage.Name = "parametersTabPage";
-//      this.parametersTabPage.Padding = new System.Windows.Forms.Padding(3);
-//      this.parametersTabPage.Size = new System.Drawing.Size(503, 280);
-//      this.parametersTabPage.TabIndex = 0;
-//      this.parametersTabPage.Text = "Parameters";
-//      // 
-//      // visualizationTabPage
-//      // 
-//      this.visualizationTabPage.BackColor = System.Drawing.SystemColors.Window;
-//      this.visualizationTabPage.Controls.Add(this.orienteeringSolutionView);
-//      this.visualizationTabPage.Location = new System.Drawing.Point(4, 22);
-//      this.visualizationTabPage.Name = "visualizationTabPage";
-//      this.visualizationTabPage.Padding = new System.Windows.Forms.Padding(3);
-//      this.visualizationTabPage.Size = new System.Drawing.Size(503, 280);
-//      this.visualizationTabPage.TabIndex = 1;
-//      this.visualizationTabPage.Text = "Visualization";
-//      // 
-//      // orienteeringSolutionView
-//      // 
-//      this.orienteeringSolutionView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-//                  | System.Windows.Forms.AnchorStyles.Left)
-//                  | System.Windows.Forms.AnchorStyles.Right)));
-//      this.orienteeringSolutionView.Caption = "OrienteeringSolution View";
-//      this.orienteeringSolutionView.Content = null;
-//      this.orienteeringSolutionView.Location = new System.Drawing.Point(6, 6);
-//      this.orienteeringSolutionView.Name = "orienteeringSolutionView";
-//      this.orienteeringSolutionView.ReadOnly = false;
-//      this.orienteeringSolutionView.Size = new System.Drawing.Size(491, 268);
-//      this.orienteeringSolutionView.TabIndex = 0;
-//      // 
-//      // TravelingSalesmanProblemView
-//      // 
-//      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-//      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
-//      this.Name = "OrienteeringProblemView";
-//      this.problemInstanceSplitContainer.Panel1.ResumeLayout(false);
-//      this.problemInstanceSplitContainer.Panel1.PerformLayout();
-//      this.problemInstanceSplitContainer.Panel2.ResumeLayout(false);
-//      this.problemInstanceSplitContainer.Panel2.PerformLayout();
-//      ((System.ComponentModel.ISupportInitialize)(this.problemInstanceSplitContainer)).EndInit();
-//      this.problemInstanceSplitContainer.ResumeLayout(false);
-//      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
-//      this.tabControl.ResumeLayout(false);
-//      this.parametersTabPage.ResumeLayout(false);
-//      this.visualizationTabPage.ResumeLayout(false);
-//      this.ResumeLayout(false);
-
-//    }
-
-//    #endregion
-
-//    private HeuristicLab.MainForm.WindowsForms.DragOverTabControl tabControl;
-//    private System.Windows.Forms.TabPage parametersTabPage;
-//    private System.Windows.Forms.TabPage visualizationTabPage;
-//    private OrienteeringSolutionView orienteeringSolutionView;
-//  }
-//}
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering.Views/3.3/OrienteeringProblemView.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering.Views/3.3/OrienteeringProblemView.cs	(revision 17954)
+++ 	(revision )
@@ -1,68 +1,0 @@
-﻿//#region License Information
-///* HeuristicLab
-// * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
-// *
-// * This file is part of HeuristicLab.
-// *
-// * HeuristicLab is free software: you can redistribute it and/or modify
-// * it under the terms of the GNU General Public License as published by
-// * the Free Software Foundation, either version 3 of the License, or
-// * (at your option) any later version.
-// *
-// * HeuristicLab is distributed in the hope that it will be useful,
-// * but WITHOUT ANY WARRANTY; without even the implied warranty of
-// * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// * GNU General Public License for more details.
-// *
-// * You should have received a copy of the GNU General Public License
-// * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
-// */
-//#endregion
-
-//TODO: ProblemView - Refactor to new problem view and add visualization
-
-//using System;
-//using HeuristicLab.MainForm;
-//using HeuristicLab.Optimization.Views;
-
-//namespace HeuristicLab.Problems.Orienteering.Views {
-//  [View("Orienteering Problem View")]
-//  [Content(typeof(OrienteeringProblem), true)]
-//  public partial class OrienteeringProblemView : ProblemView {
-//    public new OrienteeringProblem Content {
-//      get { return (OrienteeringProblem)base.Content; }
-//      set { base.Content = value; }
-//    }
-
-//    public OrienteeringProblemView() {
-//      InitializeComponent();
-//    }
-
-//    protected override void DeregisterContentEvents() {
-//      Content.BestKnownSolutionParameter.ValueChanged -= BestKnownSolutionParameter_ValueChanged;
-//      base.DeregisterContentEvents();
-//    }
-//    protected override void RegisterContentEvents() {
-//      base.RegisterContentEvents();
-//      Content.BestKnownSolutionParameter.ValueChanged += BestKnownSolutionParameter_ValueChanged;
-//    }
-
-//    protected override void OnContentChanged() {
-//      base.OnContentChanged();
-//      if (Content == null) {
-//        orienteeringSolutionView.Content = null;
-//      } else {
-//        orienteeringSolutionView.Content = Content.BestKnownSolution;
-//      }
-//    }
-
-//    protected override void SetEnabledStateOfControls() {
-//      base.SetEnabledStateOfControls();
-//      orienteeringSolutionView.Enabled = Content != null && !ReadOnly && !Locked;
-//    }
-
-//    private void BestKnownSolutionParameter_ValueChanged(object sender, EventArgs e) {
-//      orienteeringSolutionView.Content = Content.BestKnownSolution;
-//    }
-//  }
-//}
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/HeuristicLab.Problems.QuadraticAssignment.Views-3.3.csproj
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/HeuristicLab.Problems.QuadraticAssignment.Views-3.3.csproj	(revision 17954)
+++ branches/2521_ProblemRefactoring/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/HeuristicLab.Problems.QuadraticAssignment.Views-3.3.csproj	(revision 17955)
@@ -130,8 +130,4 @@
     <Compile Include="QAPVisualizationControl.Designer.cs">
       <DependentUpon>QAPVisualizationControl.cs</DependentUpon>
-    </Compile>
-    <Compile Include="QuadraticAssignmentProblemView.cs" />
-    <Compile Include="QuadraticAssignmentProblemView.Designer.cs">
-      <DependentUpon>QuadraticAssignmentProblemView.cs</DependentUpon>
     </Compile>
     <None Include="Plugin.cs.frame" />
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/QuadraticAssignmentProblemView.Designer.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/QuadraticAssignmentProblemView.Designer.cs	(revision 17954)
+++ 	(revision )
@@ -1,150 +1,0 @@
-﻿//#region License Information
-///* HeuristicLab
-// * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
-// *
-// * This file is part of HeuristicLab.
-// *
-// * HeuristicLab is free software: you can redistribute it and/or modify
-// * it under the terms of the GNU General Public License as published by
-// * the Free Software Foundation, either version 3 of the License, or
-// * (at your option) any later version.
-// *
-// * HeuristicLab is distributed in the hope that it will be useful,
-// * but WITHOUT ANY WARRANTY; without even the implied warranty of
-// * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// * GNU General Public License for more details.
-// *
-// * You should have received a copy of the GNU General Public License
-// * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
-// */
-//#endregion
-
-//namespace HeuristicLab.Problems.QuadraticAssignment.Views {
-//  partial class QuadraticAssignmentProblemView {
-//    /// <summary> 
-//    /// Required designer variable.
-//    /// </summary>
-//    private System.ComponentModel.IContainer components = null;
-
-//    /// <summary> 
-//    /// Clean up any resources being used.
-//    /// </summary>
-//    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-//    protected override void Dispose(bool disposing) {
-//      if (disposing && (components != null)) {
-//        components.Dispose();
-//      }
-//      base.Dispose(disposing);
-//    }
-
-//    #region Component Designer generated code
-
-//    /// <summary> 
-//    /// Required method for Designer support - do not modify 
-//    /// the contents of this method with the code editor.
-//    /// </summary>
-//    private void InitializeComponent() {
-//      this.tabControl = new System.Windows.Forms.TabControl();
-//      this.problemTabPage = new System.Windows.Forms.TabPage();
-//      this.visualizationTabPage = new System.Windows.Forms.TabPage();
-//      this.qapView = new HeuristicLab.Problems.QuadraticAssignment.Views.QAPVisualizationControl();
-//      ((System.ComponentModel.ISupportInitialize)(this.problemInstanceSplitContainer)).BeginInit();
-//      this.problemInstanceSplitContainer.Panel1.SuspendLayout();
-//      this.problemInstanceSplitContainer.Panel2.SuspendLayout();
-//      this.problemInstanceSplitContainer.SuspendLayout();
-//      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
-//      this.tabControl.SuspendLayout();
-//      this.problemTabPage.SuspendLayout();
-//      this.visualizationTabPage.SuspendLayout();
-//      this.SuspendLayout();
-//      // 
-//      // problemInstanceSplitContainer
-//      // 
-//      // 
-//      // problemInstanceSplitContainer.Panel2
-//      // 
-//      this.problemInstanceSplitContainer.Panel2.Controls.Add(this.tabControl);
-//      // 
-//      // parameterCollectionView
-//      // 
-//      this.parameterCollectionView.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)));
-//      this.parameterCollectionView.Dock = System.Windows.Forms.DockStyle.Fill;
-//      this.parameterCollectionView.Location = new System.Drawing.Point(3, 3);
-//      this.parameterCollectionView.Size = new System.Drawing.Size(497, 274);
-//      // 
-//      // nameTextBox
-//      // 
-//      this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
-//      this.errorProvider.SetIconPadding(this.nameTextBox, 2);
-//      // 
-//      // tabControl
-//      // 
-//      this.tabControl.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-//            | System.Windows.Forms.AnchorStyles.Left)
-//            | System.Windows.Forms.AnchorStyles.Right)));
-//      this.tabControl.Controls.Add(this.problemTabPage);
-//      this.tabControl.Controls.Add(this.visualizationTabPage);
-//      this.tabControl.Location = new System.Drawing.Point(0, 27);
-//      this.tabControl.Name = "tabControl";
-//      this.tabControl.SelectedIndex = 0;
-//      this.tabControl.Size = new System.Drawing.Size(511, 306);
-//      this.tabControl.TabIndex = 8;
-//      // 
-//      // problemTabPage
-//      // 
-//      this.problemTabPage.BackColor = System.Drawing.SystemColors.Window;
-//      this.problemTabPage.Controls.Add(this.parameterCollectionView);
-//      this.problemTabPage.Location = new System.Drawing.Point(4, 22);
-//      this.problemTabPage.Name = "problemTabPage";
-//      this.problemTabPage.Padding = new System.Windows.Forms.Padding(3);
-//      this.problemTabPage.Size = new System.Drawing.Size(503, 280);
-//      this.problemTabPage.TabIndex = 0;
-//      this.problemTabPage.Text = "Problem";
-//      // 
-//      // visualizationTabPage
-//      // 
-//      this.visualizationTabPage.BackColor = System.Drawing.SystemColors.Window;
-//      this.visualizationTabPage.Controls.Add(this.qapView);
-//      this.visualizationTabPage.Location = new System.Drawing.Point(4, 22);
-//      this.visualizationTabPage.Name = "visualizationTabPage";
-//      this.visualizationTabPage.Padding = new System.Windows.Forms.Padding(3);
-//      this.visualizationTabPage.Size = new System.Drawing.Size(503, 280);
-//      this.visualizationTabPage.TabIndex = 1;
-//      this.visualizationTabPage.Text = "Visualization";
-//      // 
-//      // qapView
-//      // 
-//      this.qapView.Assignment = null;
-//      this.qapView.Distances = null;
-//      this.qapView.Dock = System.Windows.Forms.DockStyle.Fill;
-//      this.qapView.Location = new System.Drawing.Point(3, 3);
-//      this.qapView.Name = "qapView";
-//      this.qapView.Size = new System.Drawing.Size(497, 274);
-//      this.qapView.TabIndex = 0;
-//      this.qapView.Weights = null;
-//      // 
-//      // QuadraticAssignmentProblemView
-//      // 
-//      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
-//      this.Name = "QuadraticAssignmentProblemView";
-//      this.problemInstanceSplitContainer.Panel1.ResumeLayout(false);
-//      this.problemInstanceSplitContainer.Panel2.ResumeLayout(false);
-//      this.problemInstanceSplitContainer.Panel2.PerformLayout();
-//      ((System.ComponentModel.ISupportInitialize)(this.problemInstanceSplitContainer)).EndInit();
-//      this.problemInstanceSplitContainer.ResumeLayout(false);
-//      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
-//      this.tabControl.ResumeLayout(false);
-//      this.problemTabPage.ResumeLayout(false);
-//      this.visualizationTabPage.ResumeLayout(false);
-//      this.ResumeLayout(false);
-
-//    }
-
-//    #endregion
-
-//    private System.Windows.Forms.TabControl tabControl;
-//    private System.Windows.Forms.TabPage problemTabPage;
-//    private System.Windows.Forms.TabPage visualizationTabPage;
-//    private QAPVisualizationControl qapView;
-//  }
-//}
Index: branches/2521_ProblemRefactoring/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/QuadraticAssignmentProblemView.cs
===================================================================
--- branches/2521_ProblemRefactoring/HeuristicLab.Problems.QuadraticAssignment.Views/3.3/QuadraticAssignmentProblemView.cs	(revision 17954)
+++ 	(revision )
@@ -1,82 +1,0 @@
-﻿//#region License Information
-///* HeuristicLab
-// * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
-// *
-// * This file is part of HeuristicLab.
-// *
-// * HeuristicLab is free software: you can redistribute it and/or modify
-// * it under the terms of the GNU General Public License as published by
-// * the Free Software Foundation, either version 3 of the License, or
-// * (at your option) any later version.
-// *
-// * HeuristicLab is distributed in the hope that it will be useful,
-// * but WITHOUT ANY WARRANTY; without even the implied warranty of
-// * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-// * GNU General Public License for more details.
-// *
-// * You should have received a copy of the GNU General Public License
-// * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
-// */
-//#endregion
-
-//TODO: ProblemView - Refactor to new problem view and add visualization
-
-//using System;
-//using System.Windows.Forms;
-//using HeuristicLab.MainForm;
-//using HeuristicLab.MainForm.WindowsForms;
-//using HeuristicLab.Optimization.Views;
-
-//namespace HeuristicLab.Problems.QuadraticAssignment.Views {
-//  [View("Quadratic Assignment Problem View")]
-//  [Content(typeof(QuadraticAssignmentProblem), IsDefaultView = true)]
-//  public sealed partial class QuadraticAssignmentProblemView : ProblemView {
-//    public new QuadraticAssignmentProblem Content {
-//      get { return (QuadraticAssignmentProblem)base.Content; }
-//      set { base.Content = value; }
-//    }
-
-//    public QuadraticAssignmentProblemView() {
-//      InitializeComponent();
-//    }
-
-//    protected override void RegisterContentEvents() {
-//      base.RegisterContentEvents();
-//      Content.DistancesParameter.ValueChanged += new EventHandler(DistanceMatrixParameter_ValueChanged);
-//      Content.WeightsParameter.ValueChanged += new EventHandler(WeightsParameter_ValueChanged);
-//      Content.BestKnownSolutionParameter.ValueChanged += new EventHandler(BestKnownSolutionParameter_ValueChanged);
-//    }
-
-//    protected override void DeregisterContentEvents() {
-//      Content.DistancesParameter.ValueChanged -= new EventHandler(DistanceMatrixParameter_ValueChanged);
-//      Content.WeightsParameter.ValueChanged -= new EventHandler(WeightsParameter_ValueChanged);
-//      Content.BestKnownSolutionParameter.ValueChanged -= new EventHandler(BestKnownSolutionParameter_ValueChanged);
-//      base.DeregisterContentEvents();
-//    }
-
-//    private void DistanceMatrixParameter_ValueChanged(object sender, EventArgs e) {
-//      qapView.Distances = Content.Distances;
-//    }
-
-//    private void WeightsParameter_ValueChanged(object sender, EventArgs e) {
-//      qapView.Weights = Content.Weights;
-//    }
-
-//    private void BestKnownSolutionParameter_ValueChanged(object sender, EventArgs e) {
-//      qapView.Assignment = Content.BestKnownSolution;
-//    }
-
-//    protected override void OnContentChanged() {
-//      base.OnContentChanged();
-//      if (Content != null) {
-//        qapView.Distances = Content.Distances;
-//        qapView.Weights = Content.Weights;
-//        qapView.Assignment = Content.BestKnownSolution;
-//      } else {
-//        qapView.Distances = null;
-//        qapView.Weights = null;
-//        qapView.Assignment = null;
-//      }
-//    }
-//  }
-//}